import P, { defineComponent as y } from "vue";
import k from "@nextcloud/axios";
import v from "@nextcloud/vue/dist/Components/NcButton.js";
import _ from "@nextcloud/vue/dist/Components/NcDialog.js";
import T from "@nextcloud/vue/dist/Components/NcLoadingIcon.js";
import W from "@nextcloud/vue/dist/Components/NcPasswordField.js";
import { generateUrl as z } from "@nextcloud/router";
import { getGettextBuilder as b } from "@nextcloud/l10n/gettext";
const u = "password-confirmation-dialog", D = "modal-mask", p = b().detectLocale();
[{ locale: "ar", translations: [{ msgid: "Checking password …", msgstr: ["التحقُّق من كلمة المرور ..."] }, { msgid: "Confirm", msgstr: ["تأكيد"] }, { msgid: "Confirm your password", msgstr: ["أكِّد على كلمة المرور"] }, { msgid: "Password", msgstr: ["كلمة المرور"] }, { msgid: "Please enter your password", msgstr: ["أدخِل كلمة مرورك من فضلك"] }, { msgid: "This action needs authentication", msgstr: ["هذا الإجراء يتطلب التحقُّق من الشخصية"] }, { msgid: "Wrong password", msgstr: ["كلمة مرور غير مٌطابقة"] }] }, { locale: "ast", translations: [{ msgid: "Confirm", msgstr: ["Confirmación"] }, { msgid: "Confirm your password", msgstr: ["Confirma la contraseña"] }, { msgid: "Password", msgstr: ["Contraseña"] }, { msgid: "Password confirmation dialog already mounted", msgstr: ["Yá se montó'l diálogu de confirmación de la contraseña"] }, { msgid: "This action needs authentication", msgstr: ["Esta aición precisa l'autenticación"] }, { msgid: "Wrong password", msgstr: ["La contraseña ye incorreuta"] }] }, { locale: "az", translations: [{ msgid: "Confirm", msgstr: ["Təsdiq edin"] }, { msgid: "Confirm your password", msgstr: ["Parolunuzu təsdiq edin"] }, { msgid: "Password", msgstr: ["Parol"] }, { msgid: "Password confirmation dialog already mounted", msgstr: ["Parolun təsdiqi dialoqu artıq quraşdırılıb"] }, { msgid: "This action needs authentication", msgstr: ["Bu əməliyyat autentifikasiya tələb edir"] }, { msgid: "Wrong password", msgstr: ["Səhv parol"] }] }, { locale: "cs_CZ", translations: [{ msgid: "Checking password …", msgstr: ["Ověřuji heslo…"] }, { msgid: "Confirm", msgstr: ["Potvrdit"] }, { msgid: "Confirm your password", msgstr: ["Zopakujte zadání hesla"] }, { msgid: "Password", msgstr: ["Heslo"] }, { msgid: "Please enter your password", msgstr: ["Zadejte prosím heslo"] }, { msgid: "This action needs authentication", msgstr: ["Tato akce vyžaduje ověření se"] }, { msgid: "Wrong password", msgstr: ["Nesprávné heslo"] }] }, { locale: "da", translations: [{ msgid: "Checking password …", msgstr: ["Kontrollerer adgangskoden..."] }, { msgid: "Confirm", msgstr: ["Bekræft"] }, { msgid: "Confirm your password", msgstr: ["Bekræft din adgangskode"] }, { msgid: "Password", msgstr: ["Adgangskode"] }, { msgid: "Please enter your password", msgstr: ["Indtast venligst dit kodeord"] }, { msgid: "This action needs authentication", msgstr: ["Denne handling kræver godkendelse"] }, { msgid: "Wrong password", msgstr: ["forkert Adgangskode"] }] }, { locale: "de", translations: [{ msgid: "Checking password …", msgstr: ["Prüfe Passwort …"] }, { msgid: "Confirm", msgstr: ["Bestätigen"] }, { msgid: "Confirm your password", msgstr: ["Bestätige dein Passwort"] }, { msgid: "Password", msgstr: ["Passwort"] }, { msgid: "Please enter your password", msgstr: ["Bitte geben Sie Ihr Passwort ein"] }, { msgid: "This action needs authentication", msgstr: ["Diese Aktion benötigt eine Passwortbestätigung"] }, { msgid: "Wrong password", msgstr: ["Falsches Passwort"] }] }, { locale: "de_DE", translations: [{ msgid: "Checking password …", msgstr: ["Passwort prüfen …"] }, { msgid: "Confirm", msgstr: ["Bestätigen"] }, { msgid: "Confirm your password", msgstr: ["Bestätigen Sie Ihr Passwort"] }, { msgid: "Password", msgstr: ["Passwort"] }, { msgid: "Please enter your password", msgstr: ["Bitte geben Sie Ihr Passwort ein"] }, { msgid: "This action needs authentication", msgstr: ["Diese Aktion benötigt eine Passwortbestätigung"] }, { msgid: "Wrong password", msgstr: ["Falsches Passwort"] }] }, { locale: "es", translations: [{ msgid: "Checking password …", msgstr: ["Verificando contraseña..."] }, { msgid: "Confirm", msgstr: ["Confirmar"] }, { msgid: "Confirm your password", msgstr: ["Confirme su contraseña"] }, { msgid: "Password", msgstr: ["Contraseña"] }, { msgid: "Please enter your password", msgstr: ["Introduzca su contraseña"] }, { msgid: "This action needs authentication", msgstr: ["Esta acción necesita autenticación"] }, { msgid: "Wrong password", msgstr: ["Contraseña errónea"] }] }, { locale: "fi_FI", translations: [{ msgid: "Checking password …", msgstr: ["Tarkistetaan salasanaa…"] }, { msgid: "Confirm", msgstr: ["Vahvista"] }, { msgid: "Confirm your password", msgstr: ["Vahvista salasanasi"] }, { msgid: "Password", msgstr: ["Salasana"] }, { msgid: "Please enter your password", msgstr: ["Kirjoita salasanasi"] }, { msgid: "This action needs authentication", msgstr: ["Tämä toiminto vaatii tunnistautumisen"] }, { msgid: "Wrong password", msgstr: ["Väärä salasana"] }] }, { locale: "fr", translations: [{ msgid: "Checking password …", msgstr: ["Vérification du mot de passe"] }, { msgid: "Confirm", msgstr: ["Confirmer"] }, { msgid: "Confirm your password", msgstr: ["Confirmez votre mot de passe"] }, { msgid: "Password", msgstr: ["Mot de passe"] }, { msgid: "Please enter your password", msgstr: ["Veuillez saisir votre mot de passe"] }, { msgid: "This action needs authentication", msgstr: ["Cette action nécessite une authentication"] }, { msgid: "Wrong password", msgstr: ["Mot de passe incorrect"] }] }, { locale: "gl", translations: [{ msgid: "Checking password …", msgstr: ["Comprobando contrasinal ..."] }, { msgid: "Confirm", msgstr: ["Confirmar"] }, { msgid: "Confirm your password", msgstr: ["Confirmar o seu contrasinal"] }, { msgid: "Password", msgstr: ["Contrasinal"] }, { msgid: "Please enter your password", msgstr: ["Por favor introduza o seu contrasinal"] }, { msgid: "This action needs authentication", msgstr: ["Esta acción necesita autenticación"] }, { msgid: "Wrong password", msgstr: ["Contrasinal incorrecto"] }] }, { locale: "hu_HU", translations: [{ msgid: "Confirm", msgstr: ["Jóváhagyás"] }, { msgid: "Confirm your password", msgstr: ["Hagyja jóvá a jelszavát"] }, { msgid: "Password", msgstr: ["Jelszó"] }, { msgid: "Password confirmation dialog already mounted", msgstr: ["A jelszó jóváhagyási dialógus már fel van csatolva"] }, { msgid: "This action needs authentication", msgstr: ["A művelethez bejelentkezés szükséges"] }, { msgid: "Wrong password", msgstr: ["Hibás jelszó"] }] }, { locale: "id", translations: [{ msgid: "Confirm", msgstr: ["Konfirmasi"] }, { msgid: "Confirm your password", msgstr: ["Konfirmasi kata sandi Anda"] }, { msgid: "Password", msgstr: ["Kata sandi"] }, { msgid: "Password confirmation dialog already mounted", msgstr: ["Dialog konfirmasi kata sandi sudah dipasang"] }, { msgid: "This action needs authentication", msgstr: ["Tindakan ini memerlukan autentikasi"] }, { msgid: "Wrong password", msgstr: ["Kata sandi salah"] }] }, { locale: "is", translations: [{ msgid: "Confirm", msgstr: ["Staðfesta"] }, { msgid: "Confirm your password", msgstr: ["Staðfestu lykilorðið þitt"] }, { msgid: "Password", msgstr: ["Lykilorð"] }, { msgid: "Password confirmation dialog already mounted", msgstr: ["Gluggi fyrir staðfestingu á lykilorði er þegar tengdur"] }, { msgid: "This action needs authentication", msgstr: ["Þessi aðgerð krefst auðkenningar"] }, { msgid: "Wrong password", msgstr: ["Rangt lykilorð"] }] }, { locale: "it", translations: [{ msgid: "Confirm", msgstr: ["Conferma"] }, { msgid: "Confirm your password", msgstr: ["Conferma la tua password"] }, { msgid: "Password", msgstr: ["Password"] }, { msgid: "Password confirmation dialog already mounted", msgstr: ["Finestra di conferma della password già montata"] }, { msgid: "This action needs authentication", msgstr: ["Questa azione richiede l'autenticazione"] }, { msgid: "Wrong password", msgstr: ["Password errata"] }] }, { locale: "nl", translations: [{ msgid: "Confirm", msgstr: ["Bevestig"] }, { msgid: "Confirm your password", msgstr: ["Bevestig met je wachtwoord"] }, { msgid: "Password", msgstr: ["Wachtwoord"] }, { msgid: "Password confirmation dialog already mounted", msgstr: ["Dialoog voor bevestiging met wachtwoord wordt al getoond"] }, { msgid: "This action needs authentication", msgstr: ["Voor deze actie is authenticatie vereist"] }, { msgid: "Wrong password", msgstr: ["Wachtwoord verkeerd"] }] }, { locale: "pl", translations: [{ msgid: "Confirm", msgstr: ["Potwierdź"] }, { msgid: "Confirm your password", msgstr: ["Potwierdź swoje hasło"] }, { msgid: "Password", msgstr: ["Hasło"] }, { msgid: "Password confirmation dialog already mounted", msgstr: ["Okno dialogowe potwierdzenia hasła jest już zamontowane"] }, { msgid: "This action needs authentication", msgstr: ["Wykonanie tej czynności wymaga autoryzacji"] }, { msgid: "Wrong password", msgstr: ["Nieprawidłowe hasło"] }] }, { locale: "pt_BR", translations: [{ msgid: "Checking password …", msgstr: ["Verificando senha ..."] }, { msgid: "Confirm", msgstr: ["Confirmar"] }, { msgid: "Confirm your password", msgstr: ["Confirme sua senha"] }, { msgid: "Password", msgstr: ["Senha"] }, { msgid: "Please enter your password", msgstr: ["Por favor insira sua senha"] }, { msgid: "This action needs authentication", msgstr: ["Essa ação precisa ser autenticada"] }, { msgid: "Wrong password", msgstr: ["Senha incorreta"] }] }, { locale: "ro", translations: [{ msgid: "Confirm", msgstr: ["Confirmare"] }, { msgid: "Confirm your password", msgstr: ["Confirmare parolă"] }, { msgid: "Password", msgstr: ["Parolă"] }, { msgid: "Password confirmation dialog already mounted", msgstr: ["Dialog confirmare parolă deja atașat"] }, { msgid: "This action needs authentication", msgstr: ["Această acțiune necesită autentificare"] }, { msgid: "Wrong password", msgstr: ["Parolă incorectă"] }] }, { locale: "ru", translations: [{ msgid: "Confirm", msgstr: ["Подтвердить"] }, { msgid: "Confirm your password", msgstr: ["Подтвердите пароль"] }, { msgid: "Password", msgstr: ["Пароль"] }, { msgid: "Password confirmation dialog already mounted", msgstr: ["Диалоговое окно подтверждения пароля уже установлено"] }, { msgid: "This action needs authentication", msgstr: ["Для этого действия требуется аутентификация"] }, { msgid: "Wrong password", msgstr: ["Неправильный пароль"] }] }, { locale: "sr", translations: [{ msgid: "Confirm", msgstr: ["Потврда"] }, { msgid: "Confirm your password", msgstr: ["Потврдите своју лозинку"] }, { msgid: "Password", msgstr: ["Лозинка"] }, { msgid: "Password confirmation dialog already mounted", msgstr: ["Већ је приказан дијалог за потврђивање лозинке"] }, { msgid: "This action needs authentication", msgstr: ["За ову акцију је неопходна пријава"] }, { msgid: "Wrong password", msgstr: ["Погрешна лозинка"] }] }, { locale: "sv", translations: [{ msgid: "Checking password …", msgstr: ["Kontrollerar lösenord ..."] }, { msgid: "Confirm", msgstr: ["Bekräfta"] }, { msgid: "Confirm your password", msgstr: ["Bekräfta ditt lösenord"] }, { msgid: "Password", msgstr: ["Lösenord"] }, { msgid: "Please enter your password", msgstr: ["Ange ditt lösenord"] }, { msgid: "This action needs authentication", msgstr: ["Den här åtgärden behöver autentisering"] }, { msgid: "Wrong password", msgstr: ["Fel lösenord"] }] }, { locale: "tr", translations: [{ msgid: "Checking password …", msgstr: ["Parola dorulanıyor…"] }, { msgid: "Confirm", msgstr: ["Parola onayı"] }, { msgid: "Confirm your password", msgstr: ["Parola onayı"] }, { msgid: "Password", msgstr: ["Parola"] }, { msgid: "Please enter your password", msgstr: ["Lütfen parolanızı yazın"] }, { msgid: "This action needs authentication", msgstr: ["Bu işlem için kimliğin doğrulanması gereklidir"] }, { msgid: "Wrong password", msgstr: ["Parola geçersiz"] }] }, { locale: "uk", translations: [{ msgid: "Checking password …", msgstr: ["Перевірка паролю ..."] }, { msgid: "Confirm", msgstr: ["Підтвердити"] }, { msgid: "Confirm your password", msgstr: ["Підтвердити ваш пароль"] }, { msgid: "Password", msgstr: ["Пароль"] }, { msgid: "Please enter your password", msgstr: ["Зазначте ваш пароль"] }, { msgid: "This action needs authentication", msgstr: ["Ця дія вимагає авторизації"] }, { msgid: "Wrong password", msgstr: ["Помилковий пароль"] }] }, { locale: "zh_CN", translations: [{ msgid: "Checking password …", msgstr: ["检查密码 ..."] }, { msgid: "Confirm", msgstr: ["确认"] }, { msgid: "Confirm your password", msgstr: ["确认你的密码"] }, { msgid: "Password", msgstr: ["密码"] }, { msgid: "Please enter your password", msgstr: ["请输入您的密码"] }, { msgid: "This action needs authentication", msgstr: ["此操作需要身份验证"] }, { msgid: "Wrong password", msgstr: ["密码错误"] }] }, { locale: "zh_TW", translations: [{ msgid: "Checking password …", msgstr: ["正在檢查密碼……"] }, { msgid: "Confirm", msgstr: ["確認"] }, { msgid: "Confirm your password", msgstr: ["確認您的密碼"] }, { msgid: "Password", msgstr: ["密碼"] }, { msgid: "Please enter your password", msgstr: ["請輸入您的密碼"] }, { msgid: "This action needs authentication", msgstr: ["此動作需要驗證"] }, { msgid: "Wrong password", msgstr: ["密碼錯誤"] }] }].map(({ locale: o, translations: s }) => p.addTranslation(o, {
  translations: {
    "": Object.fromEntries(s.map((r) => [r.msgid, r]))
  }
}));
const l = p.build();
l.ngettext.bind(l);
const g = l.gettext.bind(l), B = y({
  name: "PasswordDialog",
  components: {
    NcButton: v,
    NcDialog: _,
    NcLoadingIcon: T,
    NcPasswordField: W
  },
  setup() {
    return {
      dialogId: u
    };
  },
  data() {
    return {
      password: "",
      loading: !1,
      showError: !1
    };
  },
  computed: {
    helperText() {
      return this.showError ? this.password === "" ? g("Please enter your password") : g("Wrong password") : this.loading ? g("Checking password …") : "";
    }
  },
  mounted() {
    this.focusPasswordField();
  },
  methods: {
    t: g,
    async confirm() {
      if (this.showError = !1, this.loading = !0, this.password === "") {
        this.showError = !0;
        return;
      }
      const o = z("/login/confirm");
      try {
        const { data: s } = await k.post(o, { password: this.password });
        window.nc_lastLogin = s.lastLogin, this.$emit("confirmed");
      } catch {
        this.showError = !0, this.selectPasswordField();
      } finally {
        this.loading = !1;
      }
    },
    close(o) {
      o || this.$emit("close");
    },
    focusPasswordField() {
      this.$nextTick(() => {
        this.$refs.field.focus();
      });
    },
    selectPasswordField() {
      this.$nextTick(() => {
        this.$refs.field.select();
      });
    }
  }
});
function j(o, s, r, m, n, e, d, c) {
  var a = typeof o == "function" ? o.options : o;
  s && (a.render = s, a.staticRenderFns = r, a._compiled = !0), m && (a.functional = !0), e && (a._scopeId = "data-v-" + e);
  var t;
  if (d ? (t = function(i) {
    i = i || // cached call
    this.$vnode && this.$vnode.ssrContext || // stateful
    this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext, !i && typeof __VUE_SSR_CONTEXT__ < "u" && (i = __VUE_SSR_CONTEXT__), n && n.call(this, i), i && i._registeredComponents && i._registeredComponents.add(d);
  }, a._ssrRegister = t) : n && (t = c ? function() {
    n.call(
      this,
      (a.functional ? this.parent : this).$root.$options.shadowRoot
    );
  } : n), t)
    if (a.functional) {
      a._injectStyles = t;
      var h = a.render;
      a.render = function(C, f) {
        return t.call(f), h(C, f);
      };
    } else {
      var w = a.beforeCreate;
      a.beforeCreate = w ? [].concat(w, t) : [t];
    }
  return {
    exports: o,
    options: a
  };
}
var E = function() {
  var s = this, r = s._self._c;
  return s._self._setupProxy, r("NcDialog", { attrs: { id: s.dialogId, name: s.t("Confirm your password"), container: null, "content-classes": "vue-password-confirmation" }, on: { "update:open": s.close } }, [r("p", [s._v(s._s(s.t("This action needs authentication")))]), r("form", { staticClass: "vue-password-confirmation__form", on: { submit: function(m) {
    return m.preventDefault(), s.confirm.apply(null, arguments);
  } } }, [r("NcPasswordField", { ref: "field", attrs: { value: s.password, label: s.t("Password"), "helper-text": s.helperText, error: s.showError, required: "" }, on: { "update:value": function(m) {
    s.password = m;
  } } }), r("NcButton", { staticClass: "vue-password-confirmation__submit", attrs: { type: "primary", "native-type": "submit", disabled: !s.password }, scopedSlots: s._u([s.loading ? { key: "icon", fn: function() {
    return [r("NcLoadingIcon", { attrs: { size: 20 } })];
  }, proxy: !0 } : null], null, !0) }, [s._v(" " + s._s(s.t("Confirm")) + " ")])], 1)]);
}, A = [], $ = /* @__PURE__ */ j(
  B,
  E,
  A,
  !1,
  null,
  null,
  null,
  null
);
const L = $.exports, S = Date.now(), I = () => {
  const o = S - window.nc_pageLoad * 1e3, s = Date.now() - (o + window.nc_lastLogin * 1e3);
  return window.backendAllowsPasswordConfirmation && s > 30 * 60 * 1e3;
}, x = () => {
  if (!!document.getElementById(u))
    return Promise.reject(new Error("Password confirmation dialog already mounted"));
  if (!I())
    return Promise.resolve();
  const s = document.createElement("div");
  s.setAttribute("id", u);
  const r = Array.from(document.querySelectorAll(`.${D}`)).filter((d) => d.style.display !== "none");
  !!r.length ? r[r.length - 1].prepend(s) : document.body.appendChild(s);
  const n = P.extend(L), e = new n().$mount(s);
  return new Promise((d, c) => {
    e.$on("confirmed", () => {
      e.$destroy(), d();
    }), e.$on("close", () => {
      e.$destroy(), c(new Error("Dialog closed"));
    });
  });
};
export {
  x as confirmPassword,
  I as isPasswordConfirmationRequired
};
